import React, { useContext } from 'react';
// import { useTranslation } from 'react-i18next';
import { observer } from 'mobx-react-lite';
import { AppStoreContext } from './store/appStore';
import Snackbar from '@material-ui/core/Snackbar';
import IconButton from '@material-ui/core/IconButton';
import CloseIcon from '@material-ui/icons/Close';
import { makeStyles } from '@material-ui/styles';
var useStyles = makeStyles(function (theme) { return ({
    close: {
        padding: theme.spacing(0.5),
    },
}); });
var Notifier = observer(function (props) {
    var appStore = useContext(AppStoreContext);
    var snackMessage = appStore.snackMessage;
    // console.log(`render in notifier with `, snackMessage)
    // const { t } = useTranslation();
    var classes = useStyles();
    var hide = function () {
        appStore.setSnackMessage(undefined);
    };
    if (!snackMessage) {
        return null;
    }
    return (React.createElement(Snackbar, { anchorOrigin: {
            vertical: 'bottom',
            horizontal: 'left',
        }, open: true, autoHideDuration: 6000, onClose: hide, ContentProps: {
            'aria-describedby': 'message-id',
        }, message: snackMessage.message, action: [
            React.createElement(IconButton, { key: "close", "aria-label": "Close", color: "inherit", className: classes.close, onClick: hide },
                React.createElement(CloseIcon, null)),
        ] }));
});
export default (Notifier);
