var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
// import { AppStore } from '../store/appStore';
import axios from 'axios';
import { authStore } from '../store/authStore';
import { extractError } from '../utils/generalUtils';
var APIADDRESS = process.env.REACT_APP_APIADDRESS || '';
function addToken(headers) {
    if (authStore.token)
        headers['Authorization'] = "Bearer " + authStore.token;
}
export function fetchData(query, params, publicQuery) {
    if (publicQuery === void 0) { publicQuery = false; }
    return __awaiter(this, void 0, void 0, function () {
        var headers, config, result, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    headers = {};
                    addToken(headers);
                    config = {
                        baseURL: APIADDRESS,
                        timeout: 30 * 1000,
                        params: params,
                        headers: headers,
                    };
                    return [4 /*yield*/, axios.get((publicQuery ? '' : '/private') + "/data/" + query, config)];
                case 1:
                    result = _a.sent();
                    if (result.status === 200) {
                        return [2 /*return*/, result.data];
                    }
                    else {
                        console.error('failed at fetchData', result);
                    }
                    return [3 /*break*/, 3];
                case 2:
                    err_1 = _a.sent();
                    console.error('failed at fetchData', err_1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
export function fetchPaginatedData(query, params, offset, limit, publicQuery) {
    return __awaiter(this, void 0, void 0, function () {
        var headers, config, result, data, err_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    headers = {};
                    addToken(headers);
                    config = {
                        baseURL: APIADDRESS,
                        timeout: 30 * 1000,
                        params: params,
                        headers: headers,
                    };
                    return [4 /*yield*/, axios.get((publicQuery ? '' : '/private') + "/paginated/" + query + "/" + offset + "/" + limit, config)];
                case 1:
                    result = _a.sent();
                    if (result.status === 200) {
                        data = result.data;
                        if (Array.isArray(data.data) && data.meta) {
                            return [2 /*return*/, data];
                        }
                        else {
                            console.error('data at fetchPaginatedData is not pagination data: ', data);
                        }
                    }
                    else {
                        console.error('failed at fetchPaginatedData', result);
                    }
                    return [3 /*break*/, 3];
                case 2:
                    err_2 = _a.sent();
                    console.error('failed at fetchPaginatedData', err_2);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
export function loadActData(query, params) {
    return __awaiter(this, void 0, void 0, function () {
        var headers, config, result, e, err_3, error;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    headers = {};
                    addToken(headers);
                    config = {
                        baseURL: APIADDRESS,
                        timeout: 30 * 1000,
                        params: params,
                        headers: headers,
                    };
                    return [4 /*yield*/, axios.get(query, config)];
                case 1:
                    result = _a.sent();
                    if (result.status === 200) {
                        return [2 /*return*/, result.data];
                    }
                    else {
                        console.error('failed at loadActData', result);
                        e = {
                            error: 'server error!',
                        };
                        throw e;
                    }
                    return [3 /*break*/, 3];
                case 2:
                    err_3 = _a.sent();
                    console.error('failed at loadActData', err_3);
                    error = extractError(err_3);
                    if (!error) {
                        //FIXME show snakbar
                        throw new Error('unknown error!');
                    }
                    throw error;
                case 3: return [2 /*return*/];
            }
        });
    });
}
export function saveActData(query, data) {
    return __awaiter(this, void 0, void 0, function () {
        var headers, config, result, e, err_4, error;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    headers = {};
                    addToken(headers);
                    config = {
                        baseURL: APIADDRESS,
                        timeout: 60 * 1000,
                        headers: headers,
                    };
                    return [4 /*yield*/, axios.post(query, data, config)];
                case 1:
                    result = _a.sent();
                    if (result.status === 200) {
                        return [2 /*return*/, result.data];
                    }
                    else {
                        console.error('failed at saveActData', result);
                        e = {
                            error: 'server error!',
                        };
                        throw e;
                    }
                    return [3 /*break*/, 3];
                case 2:
                    err_4 = _a.sent();
                    console.error('failed at saveActData', err_4);
                    error = extractError(err_4);
                    if (!error) {
                        //FIXME show snakbar
                        throw new Error('unknown error!');
                    }
                    throw error;
                case 3: return [2 /*return*/];
            }
        });
    });
}
export function removeActData(query, params) {
    return __awaiter(this, void 0, void 0, function () {
        var headers, config, result, e, err_5, error;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    headers = {};
                    addToken(headers);
                    config = {
                        baseURL: APIADDRESS,
                        timeout: 60 * 1000,
                        params: params,
                        headers: headers,
                    };
                    return [4 /*yield*/, axios.delete(query, config)];
                case 1:
                    result = _a.sent();
                    if (result.status === 200) {
                        return [2 /*return*/, result.data];
                    }
                    else {
                        console.error('failed at removeActData', result);
                        e = {
                            error: 'server error!',
                        };
                        throw e;
                    }
                    return [3 /*break*/, 3];
                case 2:
                    err_5 = _a.sent();
                    console.error('failed at removeActData', err_5);
                    error = extractError(err_5);
                    if (!error) {
                        //FIXME show snakbar
                        throw new Error('unknown error!');
                    }
                    throw error;
                case 3: return [2 /*return*/];
            }
        });
    });
}
export function executeApi(executionConfig) {
    return __awaiter(this, void 0, void 0, function () {
        var headers, config, result, e, err_6, error;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    headers = executionConfig.headers || {};
                    addToken(headers);
                    config = __assign({ baseURL: APIADDRESS, timeout: 60 * 1000, headers: headers }, executionConfig);
                    return [4 /*yield*/, axios(config)];
                case 1:
                    result = _a.sent();
                    if (result.status === 200) {
                        return [2 /*return*/, result.data];
                    }
                    else {
                        console.error('failed at saveActData', result);
                        e = {
                            error: 'server error!',
                        };
                        throw e;
                    }
                    return [3 /*break*/, 3];
                case 2:
                    err_6 = _a.sent();
                    console.error('failed at saveActData', err_6);
                    error = extractError(err_6);
                    if (!error) {
                        //FIXME show snakbar
                        throw new Error('unknown error!');
                    }
                    throw error;
                case 3: return [2 /*return*/];
            }
        });
    });
}
// export async function setAppStore(_appStore: AppStore) : Promise<void>{
//   appStore = _appStore;
// }
