var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import openSocket from 'socket.io-client';
import { reaction } from 'mobx';
import { authStore } from '../store/authStore';
var socket;
var SOCKETADDRESS = process.env.REACT_APP_SOCKETADDRESS || '';
export function connectWebSocketToServer() {
    console.log("connecting websocket to " + SOCKETADDRESS);
    socket = openSocket(SOCKETADDRESS, {
        path: process.env.REACT_APP_SOCKETPATH || '/kamand-io',
    });
    socket.on('failed', function (payload) {
        console.log('socket event: error', payload);
    });
    socket.on('connect', function () {
        connected();
    });
    socket.on('connect_error', function (error) {
        console.log('socket event: connect_error', error);
    });
    socket.on('connect_timeout', function (timeout) {
        console.log('socket event: connect_timeout', timeout);
    });
    socket.on('error', function (error) {
        console.log('socket event: error', error);
    });
    socket.on('reconnect', function (attemptNumber) {
        console.log('socket event: reconnect', attemptNumber);
    });
    socket.on('reconnect_attempt', function (attemptNumber) {
        console.log('socket event: reconnect_attempt', attemptNumber);
    });
    socket.on('reconnecting', function (attemptNumber) {
        console.log('socket event: reconnecting', attemptNumber);
    });
    socket.on('reconnect_error', function (error) {
        console.log('socket event: reconnect_error', error);
    });
    socket.on('reconnect_failed', function () {
        console.log('socket event: reconnect_failed');
    });
}
function connected() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            console.log('connected');
            authorize(authStore.token);
            reaction(function () { return authStore.token || ''; }, function (token) {
                authorize(token);
            }, {
                delay: 2000,
            });
            return [2 /*return*/];
        });
    });
}
function authorize(token) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            console.log('authorizing');
            if (!socket)
                return [2 /*return*/];
            console.log('I have socket');
            if (token) {
                console.log('I have token');
                socket.emit('authorize', token);
            }
            return [2 /*return*/];
        });
    });
}
export function doAsyncActData(query, data) {
    if (!socket) {
        //TODO it should be handled properly!
        return;
    }
    socket.emit(query, data);
}
export function listenAsyncActData(query, callback) {
    if (!socket) {
        //TODO it should be handled properly!
        return;
    }
    socket.off(query, callback);
    socket.on(query, callback);
}
