import React from 'react';
import Button from '@material-ui/core/Button';
import Dialog from '@material-ui/core/Dialog';
import DialogActions from '@material-ui/core/DialogActions';
import DialogContent from '@material-ui/core/DialogContent';
import DialogContentText from '@material-ui/core/DialogContentText';
import DialogTitle from '@material-ui/core/DialogTitle';
import { useTranslation } from 'react-i18next';
export var ConfirmDialog = function (props) {
    var t = useTranslation().t;
    var handleClose = function () {
        props.closeCallback();
    };
    var handleDo = function () {
        props.closeCallback();
        props.doCallback();
    };
    return (React.createElement(React.Fragment, null,
        React.createElement(Dialog, { open: true, 
            // TransitionComponent={Transition}
            keepMounted: true, onClose: handleClose, "aria-labelledby": "alert-dialog-slide-title", "aria-describedby": "alert-dialog-slide-description" },
            React.createElement(DialogTitle, { id: "alert-dialog-slide-title" }, props.title),
            React.createElement(DialogContent, null,
                React.createElement(DialogContentText, { id: "alert-dialog-slide-description" }, props.content)),
            React.createElement(DialogActions, null,
                React.createElement(Button, { onClick: handleClose, color: "primary" }, t('dialog.delete.disagree')),
                React.createElement(Button, { onClick: handleDo, color: "primary" }, t('dialog.delete.agree'))))));
};
