var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import TextField from '@material-ui/core/TextField';
import Select from '@material-ui/core/Select';
import { DecimalInput, NumberInput } from 'react-hichestan-numberinput';
import { DateTimeInput, DateInput } from 'react-hichestan-datetimepicker';
import Switch from '@material-ui/core/Switch';
import { FormControlLabel, FormHelperText, FormControl } from '@material-ui/core';
export var TextKamandField = function (_a) {
    var value = _a.value, props = __rest(_a, ["value"]);
    if (value === undefined || value === null) {
        // console.log('make it empty')
        value = '';
    }
    return (React.createElement(TextField, __assign({ variant: 'standard', value: value }, props)));
};
export var DecimalKamandField = function (_a) {
    var value = _a.value, inputProps = _a.inputProps, props = __rest(_a, ["value", "inputProps"]);
    // console.log({value, restField});
    if (value === undefined || value === null) {
        // console.log('make it empty')
        value = '';
    }
    // a bug in material-ui, it should be done by them
    var shrink = !!value || value === 0;
    return (React.createElement(TextField, __assign({ value: value }, props, { InputLabelProps: shrink ? { shrink: shrink } : {}, InputProps: {
            inputComponent: DecimalInput,
            inputProps: inputProps,
        } })));
};
export var NumberKamandField = function (_a) {
    var value = _a.value, inputProps = _a.inputProps, props = __rest(_a, ["value", "inputProps"]);
    // console.log({value, restField});
    if (value === undefined || value === null) {
        // console.log('make it empty')
        value = '';
    }
    var shrink = !!value || value === 0;
    return (React.createElement(TextField, __assign({ value: value }, props, { InputLabelProps: shrink ? { shrink: shrink } : {}, InputProps: {
            inputComponent: NumberInput,
            inputProps: inputProps,
        } })));
};
export var DateTimeKamandField = function (_a) {
    var value = _a.value, inputProps = _a.inputProps, props = __rest(_a, ["value", "inputProps"]);
    // console.log({value, restField});
    if (value === undefined || value === null) {
        // console.log('make it empty')
        value = '';
    }
    var shrink = !!value;
    return (React.createElement(TextField, __assign({ value: value }, props, { InputLabelProps: shrink ? { shrink: shrink } : {}, InputProps: {
            inputComponent: DateTimeInput,
            inputProps: inputProps,
        } })));
};
export var DateKamandField = function (_a) {
    var value = _a.value, inputProps = _a.inputProps, props = __rest(_a, ["value", "inputProps"]);
    // console.log({value, restField});
    if (value === undefined || value === null) {
        // console.log('make it empty')
        value = '';
    }
    var shrink = !!value;
    return (React.createElement(TextField, __assign({ value: value }, props, { InputLabelProps: shrink ? { shrink: shrink } : {}, InputProps: {
            inputComponent: DateInput,
            inputProps: inputProps,
        } })));
};
export var BooleanKamandField = function (_a) {
    var id = _a.id, onChange = _a.onChange, value = _a.value, name = _a.name, label = _a.label, error = _a.error, helperText = _a.helperText, inputProps = _a.inputProps, props = __rest(_a, ["id", "onChange", "value", "name", "label", "error", "helperText", "inputProps"]);
    var helperTextId = helperText && id ? id + "-helper-text" : undefined;
    return (React.createElement(FormControl, { error: error },
        React.createElement(FormControlLabel, __assign({}, props, { label: label, control: React.createElement(Switch, __assign({}, inputProps, { name: name, onChange: onChange, checked: value, value: name })) })),
        helperText && (React.createElement(FormHelperText, { id: helperTextId }, helperText))));
};
export var SelectKamandField = function (_a) {
    var value = _a.value, children = _a.children, inputProps = _a.inputProps, onChange = _a.onChange, name = _a.name, props = __rest(_a, ["value", "children", "inputProps", "onChange", "name"]);
    // console.log({value, restField});
    if (value === undefined || value === null) {
        // console.log('make it empty')
        value = '';
    }
    var shrink = !!value;
    return (React.createElement(TextField
    // value={value}
    , __assign({}, props, { name: name, InputLabelProps: shrink ? { shrink: shrink } : {}, InputProps: {
            inputComponent: function (props) { return (React.createElement(Select, __assign({ fullWidth: true, value: value, onChange: onChange, name: name }, inputProps), children)); },
        } })));
};
