import React, { useEffect, useContext, useRef, useState } from 'react';
import { AppStoreContext } from '../store/appStore';
import { observer } from 'mobx-react-lite';
export var FilterEditor = observer(function (_a) {
    var EditorComponent = _a.EditorComponent, filterKey = _a.filterKey;
    var appStore = useContext(AppStoreContext);
    var _b = useState(''), value = _b[0], setValue = _b[1];
    var latestValue = useRef(null);
    var handleChange = function (e) {
        var newValue = e.target.checked || e.target.value;
        // const newValue = e.target.value;
        setValue(newValue);
        appStore.setFilter(filterKey, newValue);
    };
    var newValue = appStore.getFilter(filterKey);
    useEffect(function () {
        if (latestValue.current !== newValue) {
            if (newValue !== null && newValue !== undefined) {
                setValue(newValue);
            }
        }
        latestValue.current = newValue;
    }, [newValue, latestValue]);
    return React.createElement(EditorComponent, { value: value, handleChange: handleChange });
});
