var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useState, useContext, useEffect, useRef, useCallback } from 'react';
import Autocomplete from '@material-ui/lab/Autocomplete';
import TextField from '@material-ui/core/TextField';
import CircularProgress from '@material-ui/core/CircularProgress';
import IconButton from '@material-ui/core/IconButton';
import RefreshIcon from '@material-ui/icons/Refresh';
import AddIcon from '@material-ui/icons/Add';
import EditIcon from '@material-ui/icons/Edit';
import MenuItem from '@material-ui/core/MenuItem';
// import { useTranslation } from 'react-i18next';
import { makeStyles, createStyles } from '@material-ui/styles';
import { observer } from 'mobx-react-lite';
import { AppStoreContext } from '../store/appStore';
import { hash } from '../utils/generalUtils';
var useStyles = makeStyles(function (theme) { return createStyles({
    root: {
        '&:hover $indicatorContainer, &$focused $indicatorContainer': {
            // visibility: 'visible',
            display: 'block',
            backgroundColor: theme.palette.background.default,
        },
        focused: {},
    },
    /* Styles applied to the refresh indictator. */
    refreshIndicator: {
        marginRight: -2,
        padding: 4,
        color: theme.palette.action.active,
    },
    indicatorContainer: {
        // visibility: 'hidden',
        display: 'none',
        // display: 'block',
        position: 'absolute',
        right: 56,
    },
    inputRoot: {
        '& $input': {
            width: '0 !important',
        },
    },
}); });
var KamandAutoComplete = observer(function (props) {
    var name = props.name, selectedValue = props.value, defaultValue = props.defaultValue, error = props.error, helperText = props.helperText, onChange = props.onChange, label = props.label, placeholder = props.placeholder, queryKey = props.queryKey, query = props.query, publicQuery = props.publicQuery, queryParam = props.queryParam, makeupData = props.makeupData, getSuggestionValue = props.getSuggestionValue, getSuggestionDescription = props.getSuggestionDescription, getSuggestionRow = props.getSuggestionRow, translation = props.translation, filterValueOptions = props.filterValueOptions, isOptionParent = props.isOptionParent, filterParentOptions = props.filterParentOptions, acceptParent = props.acceptParent, addNew = props.addNew, multiple = props.multiple;
    var _a = useState(multiple ? [] : null), value = _a[0], setValue = _a[1];
    var _b = useState(null), insideValue = _b[0], setInsideValue = _b[1];
    var _c = useState(''), inputValue = _c[0], setInputValue = _c[1];
    var _d = useState(null), parent = _d[0], setParent = _d[1];
    var _e = useState(false), open = _e[0], setOpen = _e[1];
    var keepOpenRef = useRef(false);
    var defaultValueIsSet = useRef(false);
    var classes = useStyles();
    var appStore = useContext(AppStoreContext);
    var hashKey = queryKey + '/' + hash(JSON.stringify(queryParam));
    useEffect(function () {
        appStore.prepareQueryData(hashKey, query, queryParam, false, publicQuery, makeupData);
    }, [appStore, hashKey, query, queryParam, makeupData, publicQuery]);
    var refreshHandler = function () {
        appStore.prepareQueryData(hashKey, query, queryParam, true, publicQuery, makeupData);
    };
    var suggestionData = appStore.getQueryData(hashKey);
    useEffect(function () {
        var settingValue = selectedValue;
        if (defaultValue !== undefined) {
            if (defaultValueIsSet.current) {
                return;
            }
            settingValue = defaultValue;
        }
        if ((!multiple && settingValue !== insideValue) || (multiple && (settingValue || []).join(',') !== insideValue)) {
            if ((suggestionData === null || suggestionData === void 0 ? void 0 : suggestionData.data) && !(suggestionData === null || suggestionData === void 0 ? void 0 : suggestionData.loading)) {
                if (!multiple) {
                    var newValue = !settingValue ? null : suggestionData.data.find(function (row) { return getSuggestionValue(row) === settingValue; });
                    setInsideValue(newValue ? getSuggestionValue(newValue) : null);
                    setValue(newValue || null);
                    defaultValueIsSet.current = true;
                    setInputValue(getSuggestionDescription(newValue));
                }
                else if (multiple && settingValue) {
                    var values = settingValue || [];
                    var newValue = values.map(function (v) { return suggestionData.data.find(function (row) { return getSuggestionValue(row) === v; }); });
                    setInsideValue(newValue.filter(function (v) { return !!v; }).map(function (v) { return getSuggestionValue(v); }).join(','));
                    setValue(newValue);
                    defaultValueIsSet.current = true;
                    setInputValue('');
                }
                else if (multiple && !settingValue) {
                    setValue([]);
                    defaultValueIsSet.current = true;
                    setInputValue('');
                }
            }
        }
    }, [defaultValueIsSet, appStore, suggestionData, selectedValue, defaultValue, insideValue, setInsideValue, getSuggestionValue, getSuggestionDescription, multiple]);
    var handleChange = useCallback(function (event, newValue) {
        if (!multiple && newValue) {
            if (newValue.isParent) {
                setParent(newValue.parent ? __assign({ isParent: true }, newValue.parent) : null);
                if (!acceptParent) {
                    setValue(multiple ? [] : null);
                    setInputValue('');
                }
                keepOpenRef.current = true;
                // setTimeout(()=>setOpen(true), 200);
            }
            else {
                if (isOptionParent && isOptionParent(newValue)) {
                    setParent(__assign({ isParent: true, parent: parent }, newValue));
                    if (acceptParent) {
                        var eventValue = getSuggestionValue(newValue);
                        setInsideValue(eventValue);
                        if (onChange)
                            onChange({ target: { name: name, value: eventValue } });
                        setValue(newValue || null);
                        setInputValue(getSuggestionDescription(newValue));
                    }
                    else {
                        setValue(null);
                        setInputValue('');
                    }
                    keepOpenRef.current = true;
                    // setTimeout(()=>setOpen(true), 200);
                }
                else {
                    var eventValue = getSuggestionValue(newValue);
                    setInsideValue(eventValue);
                    if (onChange)
                        onChange({ target: { name: name, value: eventValue } });
                    setValue(newValue);
                    setInputValue(getSuggestionDescription(newValue));
                }
            }
        }
        else if (multiple && Array.isArray(newValue)) {
            var isItemTarget = isAttributeOf(event.target, 'data-for', 'item');
            if (newValue.length < value.length && !isItemTarget) { //user removed an item
                var eventValue = newValue.map(function (v) { return getSuggestionValue(v); });
                setInsideValue(eventValue.join(','));
                if (onChange)
                    onChange({ target: { name: name, value: eventValue } });
                setValue(newValue);
                setInputValue('');
                keepOpenRef.current = true;
            }
            else {
                var lastlySelected = void 0;
                if (newValue.length > value.length) {
                    lastlySelected = newValue[newValue.length - 1];
                }
                else {
                    lastlySelected = value.find(function (v) { return newValue.findIndex(function (nv) { return getSuggestionValue(v) === getSuggestionValue(nv); }) === -1; });
                }
                if (lastlySelected.isParent) {
                    setParent(lastlySelected.parent ? __assign({ isParent: true }, lastlySelected.parent) : null);
                    keepOpenRef.current = true;
                }
                else {
                    var isDrill = isAttributeOf(event.target, 'data-for', 'drill');
                    if (isOptionParent && isOptionParent(lastlySelected)) {
                        if (isDrill || !acceptParent)
                            setParent(__assign({ isParent: true, parent: parent }, lastlySelected));
                        if (acceptParent) {
                            if (!isDrill) {
                                var eventValue = newValue.map(function (v) { return getSuggestionValue(v); });
                                setInsideValue(eventValue.join(','));
                                if (onChange)
                                    onChange({ target: { name: name, value: eventValue } });
                                setValue(newValue);
                                setInputValue('');
                            }
                            // setInputValue(getSuggestionDescription(value));
                        }
                        else {
                            newValue.splice(newValue.length - 1);
                            setValue(newValue);
                            setInputValue('');
                        }
                        keepOpenRef.current = true;
                        // setTimeout(()=>setOpen(true), 200);
                    }
                    else {
                        var eventValue = newValue.map(function (v) { return getSuggestionValue(v); });
                        setInsideValue(eventValue.join(','));
                        if (onChange)
                            onChange({ target: { name: name, value: eventValue } });
                        setValue(newValue);
                        setInputValue('');
                        // setInputValue(getSuggestionDescription(newValue));
                    }
                }
            }
        }
        else {
            setInsideValue(null);
            if (onChange)
                onChange({ target: { name: name, value: null } });
            setValue(multiple ? [] : null);
            setInputValue('');
            if (event.type !== 'change') {
                setParent(null);
            }
        }
    }, [value, parent, name, setValue, setInputValue, setParent, onChange, getSuggestionDescription, getSuggestionValue, keepOpenRef, isOptionParent, acceptParent, multiple]);
    var onInputChange = useCallback(function (event, value) {
        if (!event || event.type === 'change') {
            setInputValue(value);
        }
    }, [setInputValue]);
    var filterOptions = useCallback(function (options, state) {
        var filtered = options;
        if (state.inputValue) {
            filtered = filterValueOptions(filtered, state.inputValue);
        }
        if (filterParentOptions) {
            filtered = filterParentOptions(filtered, parent);
        }
        return filtered;
    }, [parent, filterValueOptions, filterParentOptions]);
    var handleAddNew = function (e) { return __awaiter(void 0, void 0, void 0, function () {
        var selected, eventValue;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!addNew)
                        return [2 /*return*/];
                    return [4 /*yield*/, addNew(value, parent)];
                case 1:
                    selected = _a.sent();
                    if (selected) {
                        eventValue = getSuggestionValue(selected);
                        setInsideValue(eventValue);
                        if (onChange)
                            onChange({ target: { name: name, value: eventValue } });
                        refreshHandler();
                    }
                    return [2 /*return*/];
            }
        });
    }); };
    var handleOpen = useCallback(function () {
        setOpen(true);
        keepOpenRef.current = false;
    }, [setOpen]);
    var handleClose = useCallback(function () {
        if (!keepOpenRef.current) {
            setOpen(false);
        }
        keepOpenRef.current = false;
    }, [setOpen, keepOpenRef]);
    var handleOptionSelected = function (option, value) {
        if (option && value && getSuggestionValue(option) === getSuggestionValue(value)) {
            return true;
        }
        return false;
    };
    return (React.createElement(Autocomplete, { className: classes.root, onChange: handleChange, value: value, inputValue: inputValue, onInputChange: onInputChange, open: open, onOpen: handleOpen, onClose: handleClose, openText: translation.openText, closeText: translation.closeText, clearText: translation.clearText, noOptionsText: translation.noOptionsText, debug: false, multiple: multiple, filterOptions: filterOptions, options: (suggestionData === null || suggestionData === void 0 ? void 0 : suggestionData.data) || [], getOptionLabel: function (option) { return getSuggestionDescription(option); }, getOptionSelected: handleOptionSelected, renderOption: function (option, state) { return (React.createElement(MenuItem, { selected: state.selected, component: "div" },
            getSuggestionRow && getSuggestionRow(option),
            !getSuggestionRow && React.createElement("span", null, getSuggestionDescription(option)))); }, renderInput: function (params) {
            // debugger
            return (React.createElement(TextField, __assign({}, params, { label: label, name: name, error: error, helperText: helperText, placeholder: placeholder, fullWidth: true, variant: "standard", InputProps: __assign(__assign({}, params.InputProps), { className: params.InputProps.className + " " + classes.inputRoot, endAdornment: (React.createElement(React.Fragment, null,
                        suggestionData && suggestionData.loading ? React.createElement(CircularProgress, { color: "inherit", size: 20 }) : null,
                        React.createElement("div", { className: classes.indicatorContainer },
                            !suggestionData || !suggestionData.loading ? (React.createElement(IconButton, { className: classes.refreshIndicator, size: "small", onClick: refreshHandler },
                                React.createElement(RefreshIcon, { fontSize: "small" }))) : null,
                            addNew ? (React.createElement(IconButton, { className: classes.refreshIndicator, size: "small", onClick: handleAddNew }, value ? React.createElement(EditIcon, { fontSize: "small" }) : React.createElement(AddIcon, null))) : null),
                        params.InputProps.endAdornment)) }) })));
        } }));
});
export default KamandAutoComplete;
export var AutoCompleteWithAdd = function (props) {
    var AutoCompleteFiled = props.AutoCompleteFiled, EntryDialog = props.EntryDialog, rest = __rest(props, ["AutoCompleteFiled", "EntryDialog"]);
    var _a = useState(false), open = _a[0], setOpen = _a[1];
    var _b = useState(null), parent = _b[0], setParent = _b[1];
    var _c = useState(null), value = _c[0], setValue = _c[1];
    var handleClose = function () {
        setOpen(false);
        if (resolveRef.current) {
            resolveRef.current(null);
        }
    };
    var handleSaved = function (value) {
        setOpen(false);
        if (resolveRef.current) {
            resolveRef.current(value);
        }
    };
    var resolveRef = useRef(null);
    var handleAddNew = function (value, parent) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            setValue(value || null);
            setParent(parent);
            setOpen(true);
            return [2 /*return*/, new Promise(function (resolve) {
                    resolveRef.current = resolve;
                })];
        });
    }); };
    return (React.createElement(React.Fragment, null,
        React.createElement(AutoCompleteFiled, __assign({ addNew: handleAddNew }, rest)),
        React.createElement(EntryDialog, { open: open, onSaved: handleSaved, onClose: handleClose, filter: __assign(__assign({}, props.filter), { parent: parent, value: value }) })));
};
function isAttributeOf(element, attr, value, asHighAs) {
    var _a;
    var matched = ((_a = element === null || element === void 0 ? void 0 : element.attributes[attr]) === null || _a === void 0 ? void 0 : _a.value) === value;
    if (matched)
        return true;
    if (asHighAs === 0)
        return false;
    if (!asHighAs)
        asHighAs = 4;
    if (element === null || element === void 0 ? void 0 : element.parentElement) {
        return isAttributeOf(element === null || element === void 0 ? void 0 : element.parentElement, attr, value, asHighAs - 1);
    }
    return false;
}
