var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useState, useEffect, useRef } from 'react';
import Autocomplete from '@material-ui/lab/Autocomplete';
import TextField from '@material-ui/core/TextField';
import MenuItem from '@material-ui/core/MenuItem';
// import { useTranslation } from 'react-i18next';
import { makeStyles, createStyles } from '@material-ui/styles';
import { observer } from 'mobx-react-lite';
var useStyles = makeStyles(function (theme) { return createStyles({
    root: {},
    inputRoot: {
        '& $input': {
            width: '0 !important',
        },
    },
}); });
var KamandStaticAutoComplete = observer(function (props) {
    var name = props.name, selectedValue = props.value, defaultValue = props.defaultValue, error = props.error, helperText = props.helperText, onChange = props.onChange, label = props.label, placeholder = props.placeholder, getSuggestionValue = props.getSuggestionValue, getSuggestionDescription = props.getSuggestionDescription, getSuggestionRow = props.getSuggestionRow, translation = props.translation, filterValueOptions = props.filterValueOptions, getListSuggestions = props.getListSuggestions, multiple = props.multiple;
    var _a = useState(multiple ? [] : null), value = _a[0], setValue = _a[1];
    var _b = useState(null), insideValue = _b[0], setInsideValue = _b[1];
    var defaultValueIsSet = useRef(false);
    var classes = useStyles();
    var suggestionData = getListSuggestions();
    useEffect(function () {
        var settingValue = selectedValue;
        if (defaultValue !== undefined) {
            if (defaultValueIsSet.current) {
                return;
            }
            settingValue = defaultValue;
        }
        if ((!multiple && settingValue !== insideValue) || (multiple && (settingValue || []).join(',') !== insideValue)) {
            if (suggestionData) {
                if (!multiple) {
                    setInsideValue(settingValue);
                    var newValue = !settingValue ? null : suggestionData.find(function (row) { return getSuggestionValue(row) === settingValue; });
                    setValue(newValue);
                    defaultValueIsSet.current = true;
                }
                else if (multiple) {
                    var values = settingValue || [];
                    setInsideValue(values.join(','));
                    var newValue = values.map(function (v) { return suggestionData.find(function (row) { return getSuggestionValue(row) === v; }); });
                    setValue(newValue);
                    defaultValueIsSet.current = true;
                }
            }
        }
    }, [defaultValueIsSet, suggestionData, selectedValue, defaultValue, insideValue, getSuggestionValue, getSuggestionDescription, multiple]);
    var handleChange = function (event, newValue) {
        if (!multiple && newValue) {
            var eventValue = getSuggestionValue(newValue);
            setInsideValue(eventValue);
            if (onChange)
                onChange({ target: { name: name, value: eventValue } });
            setValue(newValue);
        }
        else if (multiple && Array.isArray(newValue)) {
            var eventValue = newValue.map(function (v) { return getSuggestionValue(v); });
            setInsideValue(eventValue.join(','));
            if (onChange)
                onChange({ target: { name: name, value: eventValue } });
            setValue(newValue);
        }
        else {
            setInsideValue(null);
            if (onChange)
                onChange({ target: { name: name, value: '' } });
            setValue(null);
        }
    };
    var filterOptions = function (options, state) {
        var filtered = options;
        if (state.inputValue) {
            filtered = filterValueOptions(filtered, state.inputValue);
        }
        return filtered;
    };
    var handleOptionSelected = function (option, value) {
        if (option && value && getSuggestionValue(option) === getSuggestionValue(value)) {
            return true;
        }
        return false;
    };
    return (React.createElement(Autocomplete, { className: classes.root, onChange: handleChange, value: value, openText: translation.openText, closeText: translation.closeText, clearText: translation.clearText, noOptionsText: translation.noOptionsText, debug: false, multiple: multiple, filterOptions: filterOptions, options: suggestionData || [], getOptionLabel: function (option) { return getSuggestionDescription(option); }, getOptionSelected: handleOptionSelected, renderOption: function (option, state) { return (React.createElement(MenuItem, { selected: state.selected, component: "div" },
            getSuggestionRow && getSuggestionRow(option),
            !getSuggestionRow && React.createElement("span", null, getSuggestionDescription(option)))); }, renderInput: function (params) { return (React.createElement(TextField, __assign({}, params, { InputProps: __assign(__assign({}, params.InputProps), { className: params.InputProps.className + " " + classes.inputRoot }), label: label, name: name, error: error, helperText: helperText, placeholder: placeholder, fullWidth: true, variant: "standard" }))); } }));
});
export default KamandStaticAutoComplete;
