var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import TextField from '@material-ui/core/TextField';
import { DecimalInput as HichestanDecimalInput, NumberInput as HichestanNumberInput } from 'react-hichestan-numberinput';
import { DateTimeInput as HichestanDateTimeInput, DateInput as HichestanDateInput } from 'react-hichestan-datetimepicker';
import Select from '@material-ui/core/Select';
import Switch from '@material-ui/core/Switch';
import { FormControlLabel, FormControl } from '@material-ui/core';
export var NumberInput = function (props) {
    var _a = props.input, name = _a.name, onChange = _a.onChange, value = _a.value, restInput = __rest(_a, ["name", "onChange", "value"]), meta = props.meta, inputProps = props.inputProps, rest = __rest(props, ["input", "meta", "inputProps"]);
    var showError = ((meta.submitError && !meta.dirtySinceLastSubmit) || meta.error) && meta.touched;
    return (React.createElement(TextField, __assign({}, rest, { name: name, helperText: showError ? meta.error || meta.submitError : undefined, error: showError, inputProps: restInput, onChange: onChange, value: value, 
        // defaultValue={value}
        InputProps: {
            inputComponent: HichestanNumberInput,
            inputProps: inputProps,
        } })));
};
export var DecimalInput = function (props) {
    var _a = props.input, name = _a.name, onChange = _a.onChange, value = _a.value, restInput = __rest(_a, ["name", "onChange", "value"]), meta = props.meta, inputProps = props.inputProps, rest = __rest(props, ["input", "meta", "inputProps"]);
    var showError = ((meta.submitError && !meta.dirtySinceLastSubmit) || meta.error) && meta.touched;
    return (React.createElement(TextField, __assign({}, rest, { name: name, helperText: showError ? meta.error || meta.submitError : undefined, error: showError, inputProps: restInput, onChange: onChange, value: value, 
        // defaultValue={value}
        InputProps: {
            inputComponent: HichestanDecimalInput,
            inputProps: inputProps,
        } })));
};
export var DateInput = function (props) {
    var inputProps = props.inputProps, value = props.value, rest = __rest(props, ["inputProps", "value"]);
    if (value === undefined || value === null) {
        value = '';
    }
    var shrink = !!value;
    return (React.createElement(TextField, __assign({}, rest, { value: value, InputLabelProps: shrink ? { shrink: shrink } : {}, InputProps: {
            inputComponent: HichestanDateInput,
            inputProps: inputProps,
        } })));
};
export var DateTimeInput = function (props) {
    var inputProps = props.inputProps, value = props.value, rest = __rest(props, ["inputProps", "value"]);
    if (value === undefined || value === null) {
        value = '';
    }
    var shrink = !!value;
    return (React.createElement(TextField, __assign({}, rest, { value: value, InputLabelProps: shrink ? { shrink: shrink } : {}, InputProps: {
            inputComponent: HichestanDateTimeInput,
            inputProps: inputProps,
        } })));
};
export var BooleanInput = function (_a) {
    var onChange = _a.onChange, value = _a.value, defaultValue = _a.defaultValue, label = _a.label, inputProps = _a.inputProps, props = __rest(_a, ["onChange", "value", "defaultValue", "label", "inputProps"]);
    if (value === 'true')
        value = true;
    if (value === 'false')
        value = false;
    if (value !== undefined)
        value = !!value;
    if (defaultValue === 'true')
        defaultValue = true;
    if (defaultValue === 'false')
        defaultValue = false;
    if (defaultValue !== undefined)
        defaultValue = !!defaultValue;
    return (React.createElement(FormControl, null,
        React.createElement(FormControlLabel, __assign({}, props, { label: label, control: React.createElement(Switch, __assign({}, inputProps, { 
                // name={name}
                onChange: function (event) {
                    var _a;
                    onChange({ target: { value: (_a = event === null || event === void 0 ? void 0 : event.target) === null || _a === void 0 ? void 0 : _a.checked } });
                }, checked: value, defaultChecked: defaultValue })) }))));
};
export var SelectInput = function (_a) {
    var value = _a.value, children = _a.children, inputProps = _a.inputProps, onChange = _a.onChange, props = __rest(_a, ["value", "children", "inputProps", "onChange"]);
    // console.log({value, restField});
    if (value === undefined || value === null) {
        // console.log('make it empty')
        value = '';
    }
    var shrink = !!value;
    return (React.createElement(TextField
    // value={value}
    , __assign({}, props, { InputLabelProps: shrink ? { shrink: shrink } : {}, InputProps: {
            inputComponent: function (props) { return (React.createElement(Select, __assign({ fullWidth: true, value: value, onChange: onChange }, inputProps), children)); },
        } })));
};
