import React, { useRef, useEffect } from 'react';
import { useTranslation } from 'react-i18next';
import { makeStyles } from '@material-ui/styles';
import { renderDateDiff } from '../utils/dateUtils';
import { calcDateDifferences } from '../utils/dateUtils';
var useStyles = makeStyles({
    time: {
        fontSize: 12,
        '@media(max-width: 920px)': {
            fontSize: 10
        }
    }
});
var TimerSticker = function (props) {
    var spanEl = useRef(null);
    var t = useTranslation().t;
    var time = props.time;
    var classes = useStyles();
    var update = function () {
        var now = new Date();
        var text = renderDateDiff(calcDateDifferences(now, time), t);
        if (spanEl && spanEl.current !== null) {
            spanEl.current.innerText = text;
        }
    };
    useEffect(function () {
        var interval = setInterval(update, 1000);
        update();
        return function () { return clearInterval(interval); };
    });
    return (React.createElement("span", { className: classes.time, ref: spanEl }));
};
export default (TimerSticker);
