var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useContext, useCallback } from 'react';
import { observer } from 'mobx-react-lite';
import { AppStoreContext } from '../store/appStore';
// export type DataInjector<P extends object> = <
//   C extends React.FunctionComponent<P>
// >(
//   component: C,
// ) => React.FunctionComponent<P & {queryData: any}>;
// React.FunctionComponent<P>
var withData = function (Component, options) { return observer(function (props) {
    var appStore = useContext(AppStoreContext);
    var prepare = useCallback(function (forceRefresh) {
        var queryParams;
        if (typeof options.queryParams === 'function') {
            queryParams = options.queryParams(appStore);
        }
        else {
            queryParams = options.queryParams;
        }
        // console.log(`execute prepareQuery with ${queryParams}`)
        appStore.prepareQueryData(options.key, options.query, queryParams, forceRefresh, options.publicQuery);
    }, [appStore]);
    useEffect(function () {
        prepare(false);
    }, [prepare]);
    var handleRefresh = function () {
        prepare(true);
    };
    var queryData = appStore.getQueryData(options.key);
    return React.createElement(Component, __assign({ queryData: queryData, refreshHandler: handleRefresh }, props));
}); };
export default withData;
