import React from 'react';
import { Theme } from '@material-ui/core';
import { ClassKeyOfStyles, ClassNameMap, Styles } from '@material-ui/styles/withStyles';
import './print.css';
import { ISelection } from '../store/interfaces/dataInterfaces';
declare const useStyles: (props?: any) => Record<"page" | "table" | "root" | "@media screen" | "@media print" | "btnContainer" | "backBtn" | "tableScroll" | "rowRoot" | "selectedRow" | "cellHiddenPrint" | "headerCell1" | "headerCell2" | "summaryCell3" | "summarySpaceHolder" | "invisible" | "cellClickable" | "cellCode" | "cellNumber", string>;
declare type ReportStyles = keyof ReturnType<typeof useStyles>;
export declare type ReportClasses = ClassNameMap<ClassKeyOfStyles<Styles<Theme, {}, ReportStyles>>>;
interface FilterEditorProps {
    value: any;
    handleChange: ((e: any) => void);
    label: string;
}
export interface FilterField {
    key: string;
    label: string;
    mandatory: boolean;
    advanced?: boolean;
    source: 'auth' | 'app';
    editor?: {
        EditorComponent: React.FunctionComponent<FilterEditorProps>;
    };
}
export declare const provideFilterKeys: (filters: FilterField[]) => string[];
interface TableProps {
    queryParams: any;
    data: any[];
    classes: ReportClasses;
    selection: ISelection;
    filterKeys: string[];
}
interface HeaderProps {
    queryParams: any;
    classes: ReportClasses;
}
interface IProps {
    query: string;
    title: string;
    filters: FilterField[];
    TableComponent: React.FunctionComponent<TableProps>;
    HeaderComponent: React.FunctionComponent<HeaderProps>;
}
declare const _default: React.FunctionComponent<IProps>;
export default _default;
export declare const makeReportUrl: (baseUser: string, filterKeys: string[], argParams: any, queryParams: any) => string;
