import React from 'react';
import { Theme } from '@material-ui/core';
import { ClassKeyOfStyles, ClassNameMap, Styles } from '@material-ui/styles/withStyles';
import { IDataOptions } from '../hooks/useKamandData';
declare const useStyles: (props?: any) => Record<"data" | "inline" | "root" | "skeleton" | "dataRow" | "actionLink" | "actionContent" | "bottomDivider" | "detailContainer" | "refresh" | "cellCenter" | "cellStart" | "cellRight", string>;
declare type WidgetStyles = keyof ReturnType<typeof useStyles>;
export declare type WidgetClasses = ClassNameMap<ClassKeyOfStyles<Styles<Theme, {}, WidgetStyles>>>;
declare const StatWidget: React.FunctionComponent<WidgetProps>;
interface WidgetProps {
    title: string;
    dataOptions: IDataOptions;
    idKey?: string;
    expandable?: boolean | ((data: any) => boolean);
    RowComponent: React.FunctionComponent<WidgetRowProps>;
    ActionComponent?: React.FunctionComponent<WidgetActionProps>;
}
export interface WidgetRowProps {
    data: any;
    classes: WidgetClasses;
    expanded?: boolean;
    onExpand?: () => void;
}
export interface WidgetActionProps {
    classes: WidgetClasses;
}
export default StatWidget;
interface StatRowDetailProps {
    dataOptions: IDataOptions;
    idKey?: string;
    expandable?: boolean | ((data: any) => boolean);
    RowComponent: React.FunctionComponent<WidgetRowProps>;
}
export declare const StatRowDetail: React.FunctionComponent<StatRowDetailProps>;
