var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useState } from 'react';
import { observer } from 'mobx-react-lite';
import { Paper, Grid, Button, Typography, Divider, } from '@material-ui/core';
import Skeleton from '@material-ui/lab/Skeleton';
import ExpandMoreIcon from '@material-ui/icons/ExpandMore';
import ExpandLessIcon from '@material-ui/icons/ExpandLess';
import { makeStyles, createStyles } from '@material-ui/styles';
import RefreshIcon from '@material-ui/icons/Refresh';
import useObservedKamandData from '../hooks/useObservedKamandData';
var useStyles = makeStyles(function (theme) { return createStyles({
    root: {
        // minHeight: 100,
        // display: 'flex',
        // flexDirection: 'column',
        padding: 10,
    },
    skeleton: {
    // flex: 1,
    // margin: 10,
    },
    inline: {
        display: 'inline-block',
    },
    dataRow: {
        padding: 10,
    },
    data: {
        marginLeft: '0.4em',
        marginRight: '0.4em',
        boxSizing: 'border-box',
    },
    actionLink: {
        color: theme.palette.text.primary,
        textDecoration: 'none',
    },
    actionContent: {
        color: theme.palette.primary.contrastText,
    },
    bottomDivider: {
        height: '1em',
        marginTop: '0.2em',
        marginBottom: '0.2em',
    },
    detailContainer: {
        maxHeight: 200,
        overflowY: 'auto'
    },
    cellCenter: {
        flip: false,
        textAlign: 'left',
        textOverflow: 'ellipsis',
        whiteSpace: 'nowrap',
        overflow: 'hidden',
    },
    cellStart: {
        flip: false,
        textAlign: 'start',
        textOverflow: 'ellipsis',
        whiteSpace: 'nowrap',
        overflow: 'hidden',
        paddingLeft: 8,
        paddingRight: 8,
    },
    cellRight: {
        flip: false,
        textAlign: 'right',
        textOverflow: 'ellipsis',
        whiteSpace: 'nowrap',
        overflow: 'hidden',
        paddingLeft: 8,
    },
    refresh: {
        padding: 0,
    },
}); });
var StatWidget = observer(function (props) {
    var classes = useStyles();
    // const [data, setData] = useState(false);
    var title = props.title, idKey = props.idKey, dataOptions = props.dataOptions, expandable = props.expandable, RowComponent = props.RowComponent, ActionComponent = props.ActionComponent;
    var _a = useObservedKamandData(dataOptions), queryData = _a.queryData, refreshHandler = _a.refreshHandler;
    var _b = useState({}), subTree = _b[0], setSubTree = _b[1];
    var handleExpland = function (id) {
        return function () {
            var _a;
            var value = !subTree[id];
            setSubTree(__assign(__assign({}, subTree), (_a = {}, _a[id] = value, _a)));
        };
    };
    if (!queryData)
        return null;
    return (React.createElement(Paper, { className: classes.root },
        React.createElement(Grid, { container: true, spacing: 0 },
            React.createElement(Grid, { item: true, xs: 9 },
                React.createElement(Typography, null, title)),
            React.createElement(Grid, { item: true, xs: 3 }, !queryData.loading && React.createElement(Button, { className: classes.refresh, onClick: refreshHandler },
                React.createElement(RefreshIcon, null))),
            React.createElement(Grid, { item: true, xs: 12 },
                React.createElement(Divider, null)),
            !queryData.error && queryData.loading && React.createElement(Grid, { item: true, xs: 12, className: classes.dataRow },
                React.createElement(Skeleton, null)),
            !queryData.error && !queryData.loading && queryData.data && queryData.data.map(function (td, index) {
                var rowKey = idKey ? td[idKey] : index;
                var handleClick = handleExpland(rowKey);
                var expandableRow = typeof expandable === 'function' ? expandable(td) : expandable;
                return (React.createElement(Grid, { key: rowKey, item: true, container: true, spacing: 0, xs: 12, className: classes.dataRow },
                    expandableRow && React.createElement(Grid, { item: true, xs: 1, onClick: handleClick }, subTree[rowKey] ? React.createElement(ExpandLessIcon, null) : React.createElement(ExpandMoreIcon, null)),
                    React.createElement(Grid, { item: true, container: true, spacing: 0, xs: expandableRow ? 11 : 12 },
                        React.createElement(RowComponent, { data: td, expanded: subTree[rowKey], onExpand: handleClick, classes: classes }))));
            }),
            queryData.error && (React.createElement(Grid, { item: true, xs: 12 }, "error")),
            React.createElement(Grid, { item: true, xs: 12, className: classes.bottomDivider },
                React.createElement(Divider, null)),
            ActionComponent && React.createElement(ActionComponent, { classes: classes }))));
});
export default StatWidget;
export var StatRowDetail = observer(function (props) {
    var classes = useStyles();
    var dataOptions = props.dataOptions, idKey = props.idKey, expandable = props.expandable, RowComponent = props.RowComponent;
    var _a = useObservedKamandData(dataOptions), queryData = _a.queryData, refreshHandler = _a.refreshHandler;
    var _b = useState({}), subTree = _b[0], setSubTree = _b[1];
    var handleExpland = function (id) {
        return function () {
            var _a;
            var value = !subTree[id];
            setSubTree(__assign(__assign({}, subTree), (_a = {}, _a[id] = value, _a)));
        };
    };
    if (!queryData)
        return null;
    return (React.createElement(React.Fragment, null,
        React.createElement(Grid, { item: true, xs: 12 },
            React.createElement(Divider, null)),
        React.createElement(Grid, { item: true, xs: 3 }, !queryData.loading && React.createElement(Button, { className: classes.refresh, onClick: refreshHandler },
            React.createElement(RefreshIcon, null))),
        React.createElement(Grid, { item: true, xs: 12 },
            React.createElement(Divider, null)),
        !queryData.error && queryData.loading && React.createElement(Grid, { item: true, xs: 12, className: classes.dataRow },
            React.createElement(Skeleton, null)),
        !queryData.error && !queryData.loading && queryData.data && queryData.data.map(function (td, index) {
            var rowKey = idKey ? td[idKey] : index;
            var handleClick = handleExpland(rowKey);
            var expandableRow = typeof expandable === 'function' ? expandable(td) : expandable;
            return (React.createElement(Grid, { key: rowKey, item: true, container: true, spacing: 0, xs: 12, className: classes.dataRow },
                expandableRow && React.createElement(Grid, { item: true, xs: 1, onClick: handleClick }, subTree[rowKey] ? React.createElement(ExpandLessIcon, null) : React.createElement(ExpandMoreIcon, null)),
                React.createElement(Grid, { item: true, container: true, spacing: 0, xs: expandableRow ? 11 : 12 },
                    React.createElement(RowComponent, { data: td, expanded: subTree[rowKey], onExpand: handleClick, classes: classes }))));
        }),
        queryData.error && (React.createElement(Grid, { item: true, xs: 12 }, "error")),
        React.createElement(Grid, { item: true, xs: 12, className: classes.bottomDivider },
            React.createElement(Divider, null))));
});
