import { useEffect, useContext, useCallback, useRef, useState } from 'react';
// import { observer } from 'mobx-react-lite';
import { AppStoreContext } from '../store/appStore';
import { hash } from '../utils/generalUtils';
var useKamandData = function (options) {
    var appStore = useContext(AppStoreContext);
    var hashKey = useRef(null);
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    var _a = useState(0), _ = _a[0], setRefresher = _a[1];
    var prepare = useCallback(function (forceRefresh) {
        var queryParams;
        if (typeof options.queryParams === 'function') {
            queryParams = options.queryParams();
        }
        else {
            queryParams = options.queryParams;
        }
        hashKey.current = options.query + '/' + hash(JSON.stringify(queryParams));
        var prepareIt = true;
        if (typeof options.notReady === 'function') {
            prepareIt = !options.notReady(queryParams);
        }
        else {
            prepareIt = !options.notReady;
        }
        if (prepareIt) {
            appStore.prepareQueryData(hashKey.current, options.query, queryParams, forceRefresh, options.publicQuery);
            setRefresher(function (r) { return r + 1; });
        }
    }, [appStore, options, setRefresher]);
    var queryData = hashKey.current && appStore.getQueryData(hashKey.current);
    useEffect(function () {
        var queryParams;
        if (typeof options.queryParams === 'function') {
            queryParams = options.queryParams();
        }
        else {
            queryParams = options.queryParams;
        }
        var newHash = options.query + '/' + hash(JSON.stringify(queryParams));
        if (hashKey.current !== newHash) {
            hashKey.current = newHash;
            setRefresher(function (r) { return r + 1; });
        }
    }, [options, hashKey, setRefresher]);
    useEffect(function () {
        if ((!queryData && hashKey.current) || ((queryData === null || queryData === void 0 ? void 0 : queryData.key) && hashKey.current && queryData.key !== hashKey.current))
            prepare(false);
    }, [prepare, queryData, hashKey]);
    var refreshHandler = function () {
        prepare(true);
    };
    return {
        queryData: queryData,
        refreshHandler: refreshHandler,
    };
};
export default useKamandData;
