var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { useState, useRef, useCallback, useEffect } from 'react';
import { hasNonEmptyValue, setNestedObjectValues, setIn, getIn } from '../utils/generalUtils';
export function useKamandForm(props) {
    var _this = this;
    var _a = useState(1), renderCount = _a[0], setRenderCount = _a[1];
    var rerender = function () {
        setRenderCount(renderCount + 1);
    };
    // console.log(`rerender kamand form hook`)
    var state = useRef({
        values: props.initialValues,
        errors: {},
        touched: {},
        isSubmitting: false,
        isValidating: false,
        submitCount: 0,
    });
    useEffect(function () {
        if (!state.current.values && props.initialValues) {
            state.current.values = props.initialValues;
            rerender();
        }
    });
    var isDirty = useCallback(function () {
        var dirty = hasNonEmptyValue(state.current.touched);
        return dirty;
    }, [state]);
    var isSubmitting = useCallback(function () {
        return state.current.isSubmitting;
    }, [state]);
    var isValidating = useCallback(function () {
        return state.current.isValidating;
    }, [state]);
    var resetForm = function () {
        state.current.values = props.initialValues;
        state.current.touched = {};
        state.current.errors = {};
        rerender();
    };
    var submitForm = function () { return __awaiter(_this, void 0, void 0, function () {
        var errors, hasError, result, hasError;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!state.current.values)
                        return [2 /*return*/, false];
                    if (state.current.isSubmitting || state.current.isValidating)
                        return [2 /*return*/, false];
                    state.current.touched = setNestedObjectValues(state.current.values, true);
                    state.current.errors = {};
                    state.current.isValidating = true;
                    state.current.isSubmitting = true;
                    state.current.submitCount = state.current.submitCount + 1;
                    if (!props.validate) return [3 /*break*/, 2];
                    return [4 /*yield*/, props.validate(state.current.values)];
                case 1:
                    errors = _a.sent();
                    hasError = hasNonEmptyValue(errors);
                    if (hasError) {
                        state.current.isSubmitting = false;
                        state.current.isValidating = false;
                        state.current.errors = errors;
                        rerender();
                        return [2 /*return*/, false];
                    }
                    _a.label = 2;
                case 2: return [4 /*yield*/, props.submit(state.current.values, kamandForm)];
                case 3:
                    result = _a.sent();
                    if (result.errors) {
                        hasError = hasNonEmptyValue(result.errors);
                        if (hasError) {
                            state.current.isValidating = false;
                            state.current.isSubmitting = false;
                            state.current.errors = result.errors;
                            rerender();
                            return [2 /*return*/, false];
                        }
                    }
                    if (result.valuesFromServer) {
                        state.current.values = result.valuesFromServer;
                    }
                    state.current.touched = {};
                    state.current.isValidating = false;
                    state.current.isSubmitting = false;
                    rerender();
                    return [2 /*return*/, true];
            }
        });
    }); };
    var rerenderDepth = 0;
    var setFieldValue = function (path, value) { return __awaiter(_this, void 0, void 0, function () {
        var newValues, previousValues, previousValue, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    newValues = setIn(state.current.values, path, value);
                    if (newValues === state.current.values) {
                        return [2 /*return*/];
                    }
                    previousValues = state.current.values;
                    state.current.values = newValues;
                    state.current.touched = setIn(state.current.touched, path, value !== getIn(props.initialValues, path));
                    if (!props.onChange) return [3 /*break*/, 5];
                    previousValue = getIn(previousValues, path);
                    rerenderDepth++;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, 4, 5]);
                    return [4 /*yield*/, props.onChange(path, previousValue, value)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 5];
                case 3:
                    err_1 = _a.sent();
                    return [3 /*break*/, 5];
                case 4:
                    rerenderDepth--;
                    return [7 /*endfinally*/];
                case 5:
                    if (rerenderDepth === 0) {
                        rerender();
                    }
                    return [2 /*return*/];
            }
        });
    }); };
    var removeFromArray = function (pathToArray, index) {
        var array = getIn(state.current.values, pathToArray);
        if (Array.isArray(array)) {
            if (index < array.length) {
                array.splice(index, 1);
                var newValues = setIn(state.current.values, pathToArray, array);
                state.current.values = newValues;
                state.current.touched = setIn(state.current.touched, pathToArray + "[" + index + "]", true);
                rerender();
            }
        }
    };
    var changeHandler = function (e) {
        var _a = e.target, name = _a.name, value = _a.value, type = _a.type, checked = _a.checked;
        if (type === 'checkbox') {
            setFieldValue(name, checked);
        }
        else {
            setFieldValue(name, value);
        }
    };
    var getFieldProps = function (path) {
        var value = getIn(state.current.values, path);
        var errorNode = getIn(state.current.errors, path);
        var touched = getIn(state.current.touched, path);
        var error = (!!errorNode && !!touched);
        var helperText = error && errorNode;
        return {
            onChange: changeHandler,
            name: path,
            id: path,
            value: value,
            error: error,
            helperText: helperText,
        };
    };
    var getHelperText = function (path) {
        return getIn(state.current.errors, path);
    };
    var kamandForm = {
        getFieldProps: getFieldProps,
        get values() { return state.current.values; },
        isDirty: isDirty,
        isSubmitting: isSubmitting,
        isValidating: isValidating,
        submitForm: submitForm,
        resetForm: resetForm,
        setFieldValue: setFieldValue,
        removeFromArray: removeFromArray,
        getHelperText: getHelperText,
    };
    return kamandForm;
}
