import { useEffect, useContext, useCallback } from 'react';
// import { observer } from 'mobx-react-lite';
import { AppStoreContext } from '../store/appStore';
import { hash } from '../utils/generalUtils';
var useObservedKamandData = function (options) {
    var appStore = useContext(AppStoreContext);
    var queryParams;
    if (typeof options.queryParams === 'function') {
        queryParams = options.queryParams();
    }
    else {
        queryParams = options.queryParams;
    }
    var hashKey = options.query + '/' + hash(JSON.stringify(queryParams));
    var prepare = useCallback(function (forceRefresh) {
        var prepareIt = true;
        if (typeof options.notReady === 'function') {
            prepareIt = !options.notReady(queryParams);
        }
        else {
            prepareIt = !options.notReady;
        }
        if (prepareIt) {
            appStore.prepareQueryData(hashKey, options.query, queryParams, forceRefresh, options.publicQuery);
        }
    }, [appStore, options, hashKey, queryParams]);
    var queryData = appStore.getQueryData(hashKey);
    useEffect(function () {
        if (!queryData)
            prepare(false);
    }, [prepare, queryData]);
    var refreshHandler = function () {
        prepare(true);
    };
    return {
        queryData: queryData,
        refreshHandler: refreshHandler,
    };
};
export default useObservedKamandData;
