import { useEffect, useContext, useState, useRef } from 'react';
import { useLocation } from 'react-router';
import { parseSearch } from '../utils/generalUtils';
import { AppStoreContext } from '../store/appStore';
export var useSetFilter = function (filterKeys) {
    var location = useLocation();
    var appStore = useContext(AppStoreContext);
    var _a = useState(false), ready = _a[0], setReady = _a[1];
    var lastSearch = useRef(null);
    var search = location.search;
    if (search !== lastSearch.current && ready)
        setReady(false);
    useEffect(function () {
        var params = parseSearch(search);
        filterKeys.forEach(function (k) {
            var pv = params[k] || null;
            var v;
            if (pv && pv.startsWith('{') && pv.endsWith('}')) {
                v = pv.substring(1, pv.length - 1).split(',').filter(function (v) { return !!v; });
            }
            else {
                v = pv;
            }
            if (v === 'true')
                v = true;
            appStore.setFilter(k, v);
        });
        lastSearch.current = search;
        setReady(true);
    }, [search, appStore, filterKeys, lastSearch]);
    return ready;
};
export function createQueryString(params) {
    var p = params.filter(function (f) { return !!f.value; }).map(function (f) { return f.key + "=" + (Array.isArray(f.value) ? '{' + f.value.join(',') + '}' : f.value); });
    return p.length === 0 ? '' : ('?' + p.join('&'));
}
