import React, { useContext, useEffect } from 'react';
import { Link, } from "react-router-dom";
import { useTranslation } from 'react-i18next';
import { observer } from 'mobx-react-lite';
import { AppStoreContext } from '../store/appStore';
import { makeStyles } from '@material-ui/styles';
var useStyles = makeStyles({
    list: {
        width: 250,
    },
});
var NotFound = observer(function (props) {
    var t = useTranslation().t;
    var classes = useStyles();
    var appStore = useContext(AppStoreContext);
    useEffect(function () {
        appStore.setPageTitle(t('pages.not_found'));
    }, [appStore, t]);
    return (React.createElement("div", { className: classes.list },
        t('pages.not_found_content'),
        React.createElement(Link, { to: "/" }, t('pages.home'))));
});
export default (NotFound);
