import React, { useContext, useState } from 'react';
import { BrowserRouter as Router, Route, Link, Switch, } from "react-router-dom";
import { useTranslation } from 'react-i18next';
import { observer } from 'mobx-react-lite';
import { makeStyles } from '@material-ui/styles';
import AppBar from '@material-ui/core/AppBar';
import Toolbar from '@material-ui/core/Toolbar';
import IconButton from '@material-ui/core/IconButton';
import MenuIcon from '@material-ui/icons/Menu';
import Drawer from '@material-ui/core/Drawer';
import List from '@material-ui/core/List';
import Divider from '@material-ui/core/Divider';
import ListItem from '@material-ui/core/ListItem';
import ListItemIcon from '@material-ui/core/ListItemIcon';
import ListItemText from '@material-ui/core/ListItemText';
import HomeIcon from '@material-ui/icons/Home';
import ExitIcon from '@material-ui/icons/ExitToApp';
// import PublicIcon from '@material-ui/icons/Public';
import { AuthStoreContext } from '../store/authStore';
import { AppStoreContext } from '../store/appStore';
import NotFound from './NotFound';
import PageTitle from '../containers/PageTitle';
var useStyles = makeStyles({
    list: {
        width: 250,
    },
    root: {
        flexGrow: 1,
    },
    logoBox: {
        height: 60,
        marginTop: 5
    },
    content: {
        padding: 20,
    },
});
var Scaffold = observer(function (props) {
    var _a = useState(false), sideMenu = _a[0], setSideMenu = _a[1];
    var t = useTranslation().t;
    // const authStore = useContext(AuthStoreContext);
    var authStore = useContext(AuthStoreContext);
    var appStore = useContext(AppStoreContext);
    var appBarHidden = appStore.appBarHidden;
    var classes = useStyles();
    // const { user } = authStore;
    var logout = function () {
        authStore.clearUser();
    };
    return (React.createElement(Router, null,
        React.createElement("div", { className: "App" },
            appBarHidden ? null : (React.createElement(React.Fragment, null,
                React.createElement(AppBar, { position: "fixed" },
                    React.createElement(Toolbar, null,
                        React.createElement(IconButton, { color: "inherit", "aria-label": "Menu", onClick: function () { return setSideMenu(true); } },
                            React.createElement(MenuIcon, null)),
                        React.createElement("p", null),
                        React.createElement(PageTitle, { variant: "h6", color: "inherit" }),
                        React.createElement("div", { className: classes.logoBox }))),
                React.createElement("div", { style: { height: 64 } }))),
            React.createElement(Drawer, { anchor: "left", open: sideMenu, onClose: function () { return setSideMenu(false); } },
                React.createElement("div", { tabIndex: 0, role: "button", onClick: function () { return setSideMenu(false); }, onKeyDown: function () { return setSideMenu(false); }, className: classes.list },
                    React.createElement(List, null,
                        React.createElement(Link, { to: "/" },
                            React.createElement(ListItem, { button: true, key: 'home' },
                                React.createElement(ListItemIcon, null,
                                    React.createElement(HomeIcon, null)),
                                React.createElement(ListItemText, { primary: t('pages.home') }))),
                        React.createElement(Divider, null),
                        React.createElement(ListItem, { button: true, key: 'logout', onClick: logout },
                            React.createElement(ListItemIcon, null,
                                React.createElement(ExitIcon, null)),
                            React.createElement(ListItemText, { primary: t('auth.logout') })),
                        React.createElement(Divider, null),
                        props.menus),
                    React.createElement(Divider, null))),
            React.createElement("div", { className: classes.content },
                (!authStore.loggedin && props.login) && props.login,
                (authStore.loggedin || !props.login) && React.createElement(Switch, null,
                    props.home && React.createElement(Route, { exact: true, path: "/", component: props.home }),
                    props.children,
                    React.createElement(Route, { component: NotFound }))))));
});
export default (Scaffold);
