var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { observable, action, configure, makeObservable, computed } from 'mobx';
import { createContext } from 'react';
// import { setAppStore } from '../api/kamandApi';
import { fetchData, loadActData, saveActData, removeActData, fetchPaginatedData } from '../api/kamandApi';
import { hash } from '../utils/generalUtils';
import { connectWebSocketToServer, doAsyncActData, listenAsyncActData } from '../api/kamandSocket';
configure({ enforceActions: "observed" });
var AppStore = /** @class */ (function () {
    function AppStore() {
        Object.defineProperty(this, "pageTitle", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: ''
        });
        Object.defineProperty(this, "appBarHidden", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        Object.defineProperty(this, "snackMessage", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "queryData", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: observable.map({}, { deep: false })
        });
        Object.defineProperty(this, "paginatedQueryData", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: observable.map({}, { deep: false })
        });
        Object.defineProperty(this, "filtersData", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: observable.map({})
        });
        Object.defineProperty(this, "actData", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: observable.map({}, { deep: false })
        });
        Object.defineProperty(this, "optionData", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: observable.map({}, { deep: false })
        });
        Object.defineProperty(this, "loadingActData", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: {}
        });
        makeObservable(this, {
            pageTitle: observable,
            setPageTitle: action,
            appBarHidden: observable,
            hideAppBar: action,
            snackMessage: observable,
            setSnackMessage: action,
            setFilter: action,
            setQueryData: action,
            invalidateQueryDataCache: action,
            prepareQueryData: action,
            invalidatePaginatedQueryDataCache: action,
            preparePaginatedQueryData: action,
            setActData: action,
            loadActDataFirstCache: action,
            loadActData: action,
            saveActData: action,
            removeActData: action,
            setOptionData: action,
        });
        connectWebSocketToServer();
        // setAppStore(this);
    }
    Object.defineProperty(AppStore.prototype, "setPageTitle", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (pageTitle) {
            this.pageTitle = pageTitle;
        }
    });
    Object.defineProperty(AppStore.prototype, "hideAppBar", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (appBarHidden) {
            this.appBarHidden = appBarHidden;
        }
    });
    Object.defineProperty(AppStore.prototype, "setSnackMessage", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (snackMessage) {
            this.snackMessage = snackMessage;
        }
    });
    Object.defineProperty(AppStore.prototype, "setFilter", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key, filter) {
            this.filtersData.set(key, filter);
        }
    });
    Object.defineProperty(AppStore.prototype, "getFilter", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key) {
            return this.filtersData.get(key);
        }
    });
    Object.defineProperty(AppStore.prototype, "setQueryData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key, queryParams, data, loading, error) {
            if (Array.isArray(data)) {
                data.forEach(function (d, i) {
                    d.arrayIndex = i;
                });
            }
            var qd = observable.object({
                key: key,
                // queryParam: observable.map(queryParam, { deep: false }),
                queryParams: queryParams,
                data: !data ? [] : observable.array(data, { deep: false }),
                selection: new Selection(),
                loading: loading,
                error: error,
            }, {});
            this.queryData.set(key, qd);
        }
    });
    Object.defineProperty(AppStore.prototype, "getQueryData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key) {
            return this.queryData.get(key);
        }
    });
    Object.defineProperty(AppStore.prototype, "invalidateQueryDataCache", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key) {
            return this.queryData.delete(key);
        }
    });
    Object.defineProperty(AppStore.prototype, "prepareQueryData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key, query, queryParams, forceRefresh, publicQuery, makeupData) {
            if (publicQuery === void 0) { publicQuery = true; }
            return __awaiter(this, void 0, void 0, function () {
                var previousData, data, err_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(!this.queryData.has(key) || forceRefresh)) return [3 /*break*/, 4];
                            previousData = this.getQueryData(key);
                            if (previousData) {
                                this.setQueryData(key, queryParams, previousData.data, true, false);
                            }
                            else {
                                this.setQueryData(key, queryParams, undefined, true, false);
                            }
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, fetchData(query, queryParams, publicQuery)];
                        case 2:
                            data = _a.sent();
                            if (makeupData)
                                data = makeupData(data);
                            this.setQueryData(key, queryParams, data, false, !data);
                            return [3 /*break*/, 4];
                        case 3:
                            err_1 = _a.sent();
                            console.error("error while fetching data in prepareQueryData with " + err_1);
                            this.setQueryData(key, queryParams, undefined, false, true);
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        }
    });
    Object.defineProperty(AppStore.prototype, "getPaginatedQueryData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key) {
            return this.paginatedQueryData.get(key);
        }
    });
    Object.defineProperty(AppStore.prototype, "invalidatePaginatedQueryDataCache", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key) {
            this.paginatedQueryData.delete(key);
        }
    });
    Object.defineProperty(AppStore.prototype, "preparePaginatedQueryData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key, query, queryParams, forceRefresh, publicQuery, pageSize, makeupData) {
            if (publicQuery === void 0) { publicQuery = true; }
            if (pageSize === void 0) { pageSize = 10; }
            if (!this.paginatedQueryData.has(key) || forceRefresh) {
                // const previousData = this.getPaginatedQueryData(key);
                // We might need to preserve the previous data till the new one loads
                var paginatedQueryData = new PaginatedQueryData(query, queryParams, publicQuery, pageSize, makeupData);
                this.paginatedQueryData.set(key, paginatedQueryData);
                paginatedQueryData.preparePageData(0);
            }
        }
    });
    Object.defineProperty(AppStore.prototype, "setActData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key, actData) {
            this.actData.set(key, actData);
        }
    });
    Object.defineProperty(AppStore.prototype, "getActData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key) {
            return this.actData.get(key);
        }
    });
    Object.defineProperty(AppStore.prototype, "deleteActData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key) {
            return this.actData.delete(key);
        }
    });
    Object.defineProperty(AppStore.prototype, "loadActDataFirstCache", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key, query, queryParams, makeObservable) {
            return __awaiter(this, void 0, void 0, function () {
                var cache, data;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            cache = this.actData.get(key);
                            if (cache)
                                return [2 /*return*/, cache];
                            return [4 /*yield*/, this.loadActData(key, query, queryParams, makeObservable)];
                        case 1:
                            data = _a.sent();
                            return [2 /*return*/, data];
                    }
                });
            });
        }
    });
    Object.defineProperty(AppStore.prototype, "loadActData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key, query, queryParams, makeObservable) {
            return __awaiter(this, void 0, void 0, function () {
                var hashKey, data, err_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            hashKey = query + '/' + hash(JSON.stringify(queryParams));
                            if (this.loadingActData[hashKey])
                                return [2 /*return*/];
                            this.loadingActData[hashKey] = true;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, 4, 5]);
                            return [4 /*yield*/, loadActData(query, queryParams)];
                        case 2:
                            data = _a.sent();
                            if (data) {
                                if (makeObservable) {
                                    this.setActData(key, makeObservable(data));
                                }
                                else {
                                    this.setActData(key, data);
                                }
                            }
                            return [2 /*return*/, data];
                        case 3:
                            err_2 = _a.sent();
                            throw err_2;
                        case 4:
                            delete this.loadingActData[hashKey];
                            return [7 /*endfinally*/];
                        case 5: return [2 /*return*/];
                    }
                });
            });
        }
    });
    Object.defineProperty(AppStore.prototype, "saveActData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key, query, data) {
            return __awaiter(this, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (key)
                                this.setActData(key, data);
                            return [4 /*yield*/, saveActData(query, data)];
                        case 1:
                            result = _a.sent();
                            if (result && key) {
                                this.setActData(key, result);
                            }
                            return [2 /*return*/, result];
                    }
                });
            });
        }
    });
    Object.defineProperty(AppStore.prototype, "removeActData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key, query, data) {
            return __awaiter(this, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, removeActData(query, data)];
                        case 1:
                            result = _a.sent();
                            if (result && key) {
                                this.deleteActData(key);
                            }
                            return [2 /*return*/, result];
                    }
                });
            });
        }
    });
    Object.defineProperty(AppStore.prototype, "doAsyncActData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (query, data) {
            doAsyncActData(query, data);
        }
    });
    Object.defineProperty(AppStore.prototype, "listenAsyncActData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (event, callback) {
            listenAsyncActData(event, callback);
        }
    });
    Object.defineProperty(AppStore.prototype, "setOptionData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key, data) {
            this.optionData.set(key, data);
        }
    });
    Object.defineProperty(AppStore.prototype, "getOptionData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key) {
            return this.optionData.get(key);
        }
    });
    return AppStore;
}());
export { AppStore };
export var appStore = new AppStore();
export var AppStoreContext = createContext(appStore);
var Selection = /** @class */ (function () {
    function Selection() {
        Object.defineProperty(this, "selection", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: observable.map({}, { deep: false })
        });
        makeObservable(this, {
            setSelected: action,
        });
    }
    Object.defineProperty(Selection.prototype, "isSelected", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (index) {
            return !!this.selection.get(index);
        }
    });
    Object.defineProperty(Selection.prototype, "setSelected", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (index, selected) {
            if (!selected)
                this.selection.delete(index);
            else
                this.selection.set(index, selected);
        }
    });
    Object.defineProperty(Selection.prototype, "selected", {
        get: function () {
            return this.selection.size > 0;
        },
        enumerable: false,
        configurable: true
    });
    return Selection;
}());
export { Selection };
var PaginatedQueryData = /** @class */ (function () {
    function PaginatedQueryData(query, queryParams, publicQuery, pageSize, makeupData) {
        Object.defineProperty(this, "query", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: query
        });
        Object.defineProperty(this, "queryParams", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: queryParams
        });
        Object.defineProperty(this, "publicQuery", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: publicQuery
        });
        Object.defineProperty(this, "pageSize", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: pageSize
        });
        Object.defineProperty(this, "makeupData", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: makeupData
        });
        Object.defineProperty(this, "pages", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: observable.array([], { deep: false })
        });
        Object.defineProperty(this, "totalCount", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 0
        });
        Object.defineProperty(this, "activePageIndex", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 0
        });
        makeObservable(this, {
            totalCount: observable,
            activePageIndex: observable,
            setActivePageIndex: action,
            pageCount: computed,
            setMeta: action,
            currentPage: computed,
            preparePageData: action,
        });
    }
    Object.defineProperty(PaginatedQueryData.prototype, "getActivePageIndex", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function () {
            return this.activePageIndex;
        }
    });
    Object.defineProperty(PaginatedQueryData.prototype, "setActivePageIndex", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (value) {
            this.activePageIndex = value;
        }
    });
    Object.defineProperty(PaginatedQueryData.prototype, "pageCount", {
        get: function () {
            return Math.ceil(this.totalCount / this.pageSize);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PaginatedQueryData.prototype, "setMeta", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (totalCount, pageSize) {
            this.totalCount = totalCount;
            this.pageSize = pageSize;
            this.activePageIndex = 0;
        }
    });
    Object.defineProperty(PaginatedQueryData.prototype, "getPage", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (index) {
            var page = (index < 0 || index >= this.pages.length) ? undefined : this.pages[index];
            if (page) {
                return page;
            }
            else {
                this.preparePageData(index);
            }
        }
    });
    Object.defineProperty(PaginatedQueryData.prototype, "currentPage", {
        get: function () {
            return this.getPage(this.activePageIndex);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PaginatedQueryData.prototype, "preparePageData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (index) {
            return __awaiter(this, void 0, void 0, function () {
                var offset, pageData, i, result, err_3;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            offset = index * this.pageSize;
                            pageData = new PageData(index);
                            if (index > this.pages.length) {
                                for (i = this.pages.length; i <= index; i++) {
                                    console.log("setting " + i + " index");
                                    this.pages[i] = null;
                                }
                            }
                            this.pages[index] = pageData;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, fetchPaginatedData(this.query, this.queryParams, offset, this.pageSize, this.publicQuery)];
                        case 2:
                            result = _a.sent();
                            if (result) {
                                result.data = result.data.map(function (d, i) {
                                    d.arrayIndex = offset + i;
                                    _this.makeupData && _this.makeupData(d);
                                    return d;
                                });
                                if (index === 0 && result.meta.totalCount) {
                                    this.setMeta(result.meta.totalCount, result.meta.limit);
                                }
                                pageData.setData(result.data);
                            }
                            else {
                                pageData.setError();
                            }
                            return [3 /*break*/, 4];
                        case 3:
                            err_3 = _a.sent();
                            console.error("error while fetching data in prepareQueryData with " + err_3);
                            pageData.setError();
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        }
    });
    return PaginatedQueryData;
}());
export { PaginatedQueryData };
var PageData = /** @class */ (function () {
    function PageData(pageIndex) {
        Object.defineProperty(this, "pageIndex", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: pageIndex
        });
        Object.defineProperty(this, "data", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "loading", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        Object.defineProperty(this, "error", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        makeObservable(this, {
            loading: observable,
            error: observable,
            setData: action,
            setError: action,
        });
    }
    Object.defineProperty(PageData.prototype, "setData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (data) {
            this.data = data;
            this.loading = false;
            this.error = false;
        }
    });
    Object.defineProperty(PageData.prototype, "setError", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function () {
            this.data = undefined;
            this.loading = false;
            this.error = true;
        }
    });
    Object.defineProperty(PageData.prototype, "getIndex", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function () {
            return this.pageIndex;
        }
    });
    Object.defineProperty(PageData.prototype, "getData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function () {
            return this.data;
        }
    });
    return PageData;
}());
export { PageData };
