var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { observable, makeObservable, action, reaction, toJS, configure } from 'mobx';
import { createContext } from 'react';
import { login, forgot } from '../api/authApi';
configure({ enforceActions: "observed" });
var AuthStore = /** @class */ (function () {
    function AuthStore() {
        Object.defineProperty(this, "user", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "loggedin", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        Object.defineProperty(this, "token", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "optionData", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: observable.map({}, { deep: false })
        });
        makeObservable(this, {
            loggedin: observable,
            token: observable,
            user: observable.shallow,
            setUser: action,
            clearUser: action,
            login: action,
            setOptionData: action,
        });
    }
    Object.defineProperty(AuthStore.prototype, "setUser", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (user) {
            this.user = user;
            if (user.token) {
                this.loggedin = true;
                this.token = user.token;
            }
            else {
                this.loggedin = false;
                this.token = undefined;
            }
        }
    });
    Object.defineProperty(AuthStore.prototype, "clearUser", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function () {
            this.user = undefined;
            this.loggedin = false;
            this.token = undefined;
            this.optionData.clear();
        }
    });
    Object.defineProperty(AuthStore.prototype, "login", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (username, password) {
            return __awaiter(this, void 0, void 0, function () {
                var user;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, login({ username: username, password: password })];
                        case 1:
                            user = _a.sent();
                            setTimeout(function () {
                                _this.setUser(user);
                            }, 0);
                            return [2 /*return*/];
                    }
                });
            });
        }
    });
    Object.defineProperty(AuthStore.prototype, "forgot", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (username) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, forgot({ username: username })];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        }
    });
    Object.defineProperty(AuthStore.prototype, "setOptionData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key, data) {
            this.optionData.set(key, data);
        }
    });
    Object.defineProperty(AuthStore.prototype, "getOptionData", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (key) {
            return this.optionData.get(key);
        }
    });
    return AuthStore;
}());
export { AuthStore };
export var authStore = new AuthStore();
export var AuthStoreContext = createContext(authStore);
var json = localStorage.getItem('__auth__');
if (json) {
    var data = JSON.parse(json);
    if (data) {
        if (data.user) {
            authStore.setUser(data.user);
        }
        if (data.optionData) {
            for (var k in data.optionData) {
                if (!data.optionData.hasOwnProperty(k))
                    continue;
                authStore.setOptionData(k, data.optionData[k]);
            }
        }
    }
}
reaction(function () { return JSON.stringify(toJS(authStore)); }, function (json) {
    localStorage.setItem('__auth__', json);
}, {
    delay: 2000,
});
