export declare function formatDateTimeString(dateStr: string | undefined | null): string;
export declare function formatDateString(dateStr: string | undefined | null): string;
export declare function formatDateTime(date: Date | undefined | null): string;
export declare function formatDate(date: Date | undefined | null): string;
export declare function formatTime(date: Date | undefined | null): string;
export interface IDateDiff {
    days: number;
    hours: number;
    minutes: number;
    seconds: number;
    miliseconds: number;
    passed: boolean;
}
export declare function calcDateDifferences(fromDate: Date, tillDate: Date): IDateDiff;
export declare function renderDateDiff(diff: IDateDiff, t: Function): string;
export declare function constructdate(_year: number, _month: number, _day: number, seperator?: string): string;
export declare const gregorianmonthdays: number[];
export declare const jalalimonthdays: number[];
export declare function JalaliGoFirstDateOfMonth(_date: string): string;
export declare function JalaliGoLastDateOfMonth(_date: string): string;
export declare function JalaliDateToDays(_date: string): number;
export declare function JalaliDaysToDate(_days: number): string;
export declare function GregorianDateToDays(_date: string): number;
export declare function GregorianDaysToDate(_days: number): string;
export declare function Jalali2Gregorian(_jalaliDate: string): string;
export declare function Gregorian2Jalali(_gregorianDate: string): string;
export interface IFirstDay {
    firstDayDate: Date;
    jalaliDate: string;
    firstDayPersianWeekDay: number;
}
export interface ILastDay {
    lastDay: number;
    jalaliDate: string;
    lastDayDate: Date;
}
export declare function FirstDayOfJalaliMonth(year: number, month: number): IFirstDay;
export declare function LastDayOfJalaliMonth(year: number, month: number): ILastDay;
export declare function Jalali2Date(jalaliDate: string, time?: string): Date;
export declare function JalaliNow(): string;
export declare function isJalaliLapsYear(year: number): boolean;
export declare function Date2JalaliDate(date: Date): string;
export declare function test(): void;
