var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import i18n from '../translations/i18n';
export function msleep(n) {
    //  Atomics.wait(new Int32Array(new SharedArrayBuffer(4)), 0, 0, n);
    return sleep(n);
}
export function sleep(ms) {
    return new Promise(function (resolve) { return setTimeout(resolve, ms); });
}
export function extractFlatMessagesFromError(err) {
    var messages = [];
    for (var k in err) {
        if (!err.hasOwnProperty(k))
            continue;
        if (k === 'codes')
            continue;
        if (Array.isArray(err[k])) {
            messages.push.apply(messages, (err[k].map(function (e) { return !e ? '' : e.toString(); })));
        }
        else if (err[k]) {
            messages.push(err[k].toString());
        }
    }
    return messages;
}
export function extractErrorMessage(details) {
    if (typeof details === 'string') {
        return details;
    }
    if (!!!details.codes) {
        console.error("there should be a problem in extractError function in generalUtils module!");
        return tryTranslation('odd') || 'odd error';
    }
    ;
    var message = '';
    var appendError = function (c) {
        var translated = tryTranslation(c);
        message += (translated || JSON.stringify(c)) + "\n";
    };
    for (var k in details.codes) {
        if (!details.codes.hasOwnProperty(k))
            continue;
        var code = details.codes[k];
        var f = tryTranslation(k);
        message += (f || k) + ":\n";
        if (Array.isArray(code)) {
            code.forEach(appendError);
        }
        else {
            appendError(code);
            // const translated = tryTranslation(code);
            // message += `${translated || code}\n`;
        }
    }
    return message;
}
export function extractArrayError(err) {
    var error = err.reduce(function (r, e) {
        var translated = tryTranslation(e);
        var otherMessages = getIn(r, e.path);
        r = setIn(r, e.path, (otherMessages ? otherMessages + '\n' : '') + (translated || e.message));
        return r;
    }, {});
    return error;
}
export function extractError(err) {
    var details;
    var message;
    if (err && err.response && err.response.data && err.response.data.error && err.response.data.statusCode !== 200) {
        if (err.response.data.payload) {
            details = err.response.data.payload;
            message = err.response.data.payload;
        }
        else if (err.response.data.message) {
            message = err.response.data.message;
            try {
                details = JSON.parse(message);
            }
            catch (_) {
                return { message: message };
            }
        }
        else {
            message = tryTranslation('unknown') || 'unknown error';
        }
    }
    else if (err && err.payload) {
        details = err.payload;
        message = err.message || JSON.stringify(err.payload);
    }
    else if (err.message && err.message === 'Network Error') {
        message = tryTranslation('network_error') || 'network error';
    }
    else {
        message = tryTranslation('unknown') || 'unknown error';
    }
    if (details) {
        try {
            if (details) {
                console.log({ err: err, error: details });
                if (Array.isArray(details)) {
                    return extractArrayError(details);
                    // details.forEach( detail => {
                    //   translate(detail);
                    // });
                }
                else {
                    translate(details);
                }
                return details;
            }
        }
        catch (_) {
            return { message: message };
        }
    }
    return { message: message };
}
function translate(details) {
    if (!!!details.codes)
        return;
    var _loop_1 = function (k) {
        if (!details.codes.hasOwnProperty(k))
            return "continue";
        var code = details.codes[k];
        if (Array.isArray(code)) {
            code.forEach(function (c, i) {
                var translated = tryTranslation(c);
                if (translated) {
                    if (!details[k])
                        details[k] = [];
                    details[k][i] = translated;
                }
                ;
            });
        }
        else {
            var translated = tryTranslation(code);
            if (translated)
                details[k] = translated;
        }
    };
    for (var k in details.codes) {
        _loop_1(k);
    }
}
function tryTranslation(code) {
    if (typeof code === 'string') {
        var tkey = "error." + code;
        //FIXME not pure function
        var translated = i18n.t(tkey);
        if (tkey !== translated) {
            return translated;
        }
        // }else if(code instanceof IErrorCode){
    }
    else {
        var tkey = "error." + code.code;
        var translated = i18n.t(tkey, code.params);
        if (tkey !== translated) {
            return translated;
        }
    }
    return;
}
export function readParam(search, param) {
    var i1 = search.indexOf(param + '=');
    if (i1 > -1) {
        var i2 = search.indexOf('&', i1);
        if (i2 === -1)
            i2 = search.length;
        return search.substring(i1 + param.length + 1, i2);
    }
    return '';
}
export function hasRole(user, checkingRoles) {
    if (!user || !user.roles)
        return false;
    var roles = user.roles;
    if (typeof roles === 'string') {
        if (typeof checkingRoles === 'string') {
            return roles === checkingRoles;
        }
        else {
            return checkingRoles.findIndex(function (r) { return r === roles; }) > -1;
        }
    }
    if (Array.isArray(roles)) {
        if (typeof checkingRoles === 'string') {
            return roles.findIndex(function (r) { return r === checkingRoles; }) > -1;
        }
        else {
            return roles.some(function (r) { return checkingRoles.findIndex(function (cr) { return cr === r; }) > -1; });
        }
    }
    // user.roles && user.roles.findIndex( (r) => 'admin');
    return false;
}
export function hash(s) {
    return s.split("").reduce(function (a, b) { a = ((a << 5) - a) + b.charCodeAt(0); return a & a; }, 0);
}
/** @private is the given object a Function? */
export var isFunction = function (obj) {
    return typeof obj === 'function';
};
/** @private is the given object an Object? */
export var isObject = function (obj) {
    return obj !== null && typeof obj === 'object';
};
/** @private is the given object an integer? */
export var isInteger = function (obj) {
    return String(Math.floor(Number(obj))) === obj;
};
/** @private is the given object a string? */
export var isString = function (obj) {
    return Object.prototype.toString.call(obj) === '[object String]';
};
/** @private is the given object a NaN? */
// eslint-disable-next-line no-self-compare
export var isNaN = function (obj) { return obj !== obj; };
/** @private is the given object/value a promise? */
export var isPromise = function (value) {
    return isObject(value) && isFunction(value.then);
};
export var hasNonEmptyValue = function (obj) {
    if (isObject(obj)) {
        if (Array.isArray(obj)) {
            for (var _i = 0, obj_1 = obj; _i < obj_1.length; _i++) {
                var v = obj_1[_i];
                if (hasNonEmptyValue(v))
                    return true;
            }
        }
        else {
            for (var _a = 0, _b = Object.keys(obj); _a < _b.length; _a++) {
                var key = _b[_a];
                if (hasNonEmptyValue(obj[key]))
                    return true;
            }
        }
    }
    else {
        if (obj) {
            return true;
        }
    }
    return false;
};
export var toPath = function (key) {
    var path = [];
    var parts = key.split('.');
    parts.forEach(function (part) {
        var i1 = part.indexOf('[');
        if (i1 >= 0) {
            path.push(part.substring(0, i1));
            var i2 = part.indexOf(']');
            if (i2 >= 0) {
                path.push(part.substring(i1 + 1, i2));
            }
            else {
                //error but ignore
            }
        }
        else {
            path.push(part);
        }
    });
    return path;
    /*
  _.toPath('a.b.c');
  // => ['a', 'b', 'c']
   
  _.toPath('a[0].b.c');
  // => ['a', '0', 'b', 'c']
     */
};
export var clone = function (obj) {
    if (Array.isArray(obj)) {
        return __spreadArrays(obj);
    }
    else if (isObject(obj)) {
        return __assign({}, obj);
    }
    else {
        return obj;
    }
};
export function getIn(obj, key, def, p) {
    if (p === void 0) { p = 0; }
    var path = Array.isArray(key) ? key : toPath(key);
    while (obj && p < path.length) {
        obj = obj[path[p++]];
    }
    return obj === undefined ? def : obj;
}
export function setIn(obj, path, value) {
    var res = clone(obj); // this keeps inheritance when obj is a class
    var resVal = res;
    var i = 0;
    var pathArray = toPath(path);
    for (; i < pathArray.length - 1; i++) {
        var currentPath = pathArray[i];
        var currentObj = getIn(obj, pathArray.slice(0, i + 1));
        if (currentObj && (isObject(currentObj) || Array.isArray(currentObj))) {
            resVal = resVal[currentPath] = clone(currentObj);
        }
        else {
            var nextPath = pathArray[i + 1];
            resVal = resVal[currentPath] =
                isInteger(nextPath) && Number(nextPath) >= 0 ? [] : {};
        }
    }
    // Return original object if new value is the same as current
    if ((i === 0 ? obj : resVal)[pathArray[i]] === value) {
        return obj;
    }
    if (value === undefined) {
        delete resVal[pathArray[i]];
    }
    else {
        resVal[pathArray[i]] = value;
    }
    // If the path array has a single element, the loop did not run.
    // Deleting on `resVal` had no effect in this scenario, so we delete on the result instead.
    if (i === 0 && value === undefined) {
        delete res[pathArray[i]];
    }
    return res;
}
/**
 * Recursively a set the same value for all keys and arrays nested object, cloning
 * @param object
 * @param value
 * @param visited
 * @param response
 */
export function setNestedObjectValues(object, value, visited, response) {
    if (visited === void 0) { visited = new WeakMap(); }
    if (response === void 0) { response = {}; }
    for (var _i = 0, _a = Object.keys(object); _i < _a.length; _i++) {
        var k = _a[_i];
        var val = object[k];
        if (isObject(val)) {
            if (!visited.get(val)) {
                visited.set(val, true);
                // In order to keep array values consistent for both dot path  and
                // bracket syntax, we need to check if this is an array so that
                // this will output  { friends: [true] } and not { friends: { "0": true } }
                response[k] = Array.isArray(val) ? [] : {};
                setNestedObjectValues(val, value, visited, response[k]);
            }
        }
        else {
            response[k] = value;
        }
    }
    return response;
}
export var parseSearch = function (search) {
    if (search.substring(0, 1) === '?')
        search = search.substring(1);
    var params = search.split('&').map(function (p) { return p.split('='); }).reduce(function (r, p) {
        var _a;
        return (__assign(__assign({}, r), (_a = {}, _a[p[0]] = p[1], _a)));
    }, {});
    return params;
};
export var calcTotalOffset = function (element) {
    return (element.offsetTop ? element.offsetTop : 0) + (element.offsetParent ? calcTotalOffset(element.offsetParent) : 0);
};
